\ AutoQ.fth Taqoz V2.8 Tools
\ By CWE

{
   AutoL with toset and Locals in LUT
   AutoM 5.11.22 offsets for local variables corrected
   AutoN 19.12.2022 More Space for User Data
   
to Autoload, if P31=3V3  on startup:

: aload
   31 pin@ if
      " auto.f" FOPEN$ if @FILE FLOADS then
   then
;

: aload
   " auto.f" FOPEN$ if @FILE FLOADS then

;

!INITS

' aload +INIT

BACKUP BIX

}


IFDEF *CeTools*	
    \ oldCeTOrg org
    !polls
    1 cogstop
    FORGET *CeTools*  }

pub *CeTools*	PRINT" CeTools AutoQ.fth CWE " ;

\ 0 bytes oldCeTOrg

org@ := oriorg
$6C000 := userdata
userdata org

: Variables_Library ; \ { #################################################


\ { Create and Does by Bob Edwards ########################################

--- create new dev with dummy cfa (save ptr to it)
pub CREATE ( -- )
    [C] GRAB
    [C] CREATE: --- Using the next word in the input stream as the name, create a VARIABLE type dictionary entry
    [C] GRAB --- make sure CREATE: has run before anything more
    HERE 2- 0 REG W! --- save the address of the code after DOES> in the REG scratchpad area
;
--- set new cfa to point back to DOES: code (skipped by DOES: itself)
pub DOES> ( -- )
    R> --- the first word location in the new word being defined
    0 REG W@ --- retrieve the address stored on scratchpad
    W! --- set the first word to execute as the address of the code after DOES>
;


{ --- example definition of a new 'array of words' data type - no bounds checking
pre WARRAY
    CREATE ( cnt -- )
    FOR
        0 [C] ||
    NEXT --- Create cnt bytes set to 0
    DOES> ( index -- addr )
        2* R> + --- the address of the first byte + index = the entry reqd
;
--- Create a new array MARRAY1 which can hold 10 word size values
10 WARRAY MYARRAY1
}

\ }

pre ARRAY
    CREATE ( cnt -- )
    FOR
        0 [C] ,
    NEXT --- Create cnt bytes set to 0
    DOES> ( index -- addr )
        4* R> + --- the address of the first byte + index = the entry reqd
;

\ { Lut Variables ###############################################

long lutOrg \ Pointer to next free pos
$1ff lutOrg !

pre lutLongs ( n <name> ) \ create n longs private for each cpu in LUT
     create 
         lutOrg @ swap - \ decrement pointer
         dup 1+ [C] ,
         lutOrg !
     does> ( -- address )
        R> @
;

\ }


\ { Value variable type ########################################## 
: cells 4* ;

pre cpuVar ( <name> ) \ create private long variable=0 for each cpu
     create 
        8 FOR
            0 [C] ,
        NEXT --- Create 8 longs set to 0
     does> ( -- address )
        R> cogid 4* + 
;

\ Variant with lutLong
1 lutLongs tosetL
0 tosetL LUT! \ don't forget for new cog


code to
   mov r2,#tosetL
   mov r3,#1
   wrlut r3,r2
   ret
end

code +to
   mov r2,#tosetL
   mov r3,#2
   wrlut r3,r2
   ret
end

: to?
   tosetL dup . lut@ . ;

code (value) ( [newvalue] Adress -- ) '\ checks toset, 0: read, 1: store, 2: +=
            mov r2,#tosetL
            rdlut r0,r2 wz  '\ get toset
    if_z    rdlong a,a  '\ get the value
    if_z    ret
            cmp r0,#1 wz    '\ check for store
            mov r0,#0   '\ clear toset
            wrlut r0,r2
    if_z    wrlong b,a  '\ store the new value
    if_z    jmp #\@2DROP     

            rdlong r1,a  '\ get the oldvalue
            add r1,b     '\ add newvalue
            wrlong r1,a  '\ store the value
            jmp #\@2DROP     
end

pre value ( beim Anlegen wird Wert abgelegt, nach to: Wert ueberschreiben, )
    ( +to addieren, sonst wird Wert auf den Stack gelegt )
    create 
    [C] ,
    does> 
        R>
        (value)
; 


}





( 25 value foo )
( foo . )

\ } Value Variable 

: Locals_Library ; ( { simple locals Library ############################ )

$15 =: auxptr \ pointer in cog of L> auxstack

code  lValA '\ value at auxstack in LUT with offset 0
            mov r3,auxptr     
            sub r3,#1      '\ offset: -1
            mov r2,#tosetL
            >PUSHX         '\ space on stack
            rdlut a,r3     '\ get the value in tos
            rdlut r0,r2 wz  '\ get toset
   if_z     ret
            cmp r0,#1 wz    '\ check for store
            mov r0,#0   '\ clear toset
            wrlut r0,r2    
    if_nz   add b,a     '\ add old to newvalue
            wrlut b,r3  '\ store the value
            jmp #\@2DROP
end

code  lValB '\ value at auxstack in LUT with offset 
            mov r3,auxptr     
            sub r3,#2      '\ offset: -2
            mov r2,#tosetL
            >PUSHX         '\ space on stack
            rdlut a,r3     '\ get the value in tos
            rdlut r0,r2 wz  '\ get toset
   if_z     ret
            cmp r0,#1 wz    '\ check for store
            mov r0,#0   '\ clear toset
            wrlut r0,r2    
    if_nz   add b,a     '\ add old to newvalue
            wrlut b,r3  '\ store the value
            jmp #\@2DROP
end


code  lValC '\ value at auxstack in LUT with offset 
            mov r3,auxptr     
            sub r3,#3      '\ offset: -3
            mov r2,#tosetL
            >PUSHX         '\ space on stack
            rdlut a,r3     '\ get the value in tos
            rdlut r0,r2 wz  '\ get toset
   if_z     ret
            cmp r0,#1 wz    '\ check for store
            mov r0,#0   '\ clear toset
            wrlut r0,r2    
    if_nz   add b,a     '\ add old to newvalue
            wrlut b,r3  '\ store the value
            jmp #\@2DROP
end


code  lValD '\ value at auxstack in LUT with offset 
            mov r3,auxptr     
            sub r3,#4      '\ offset: -4
            mov r2,#tosetL
            >PUSHX         '\ space on stack
            rdlut a,r3     '\ get the value in tos
            rdlut r0,r2 wz  '\ get toset
   if_z     ret
            cmp r0,#1 wz    '\ check for store
            mov r0,#0   '\ clear toset
            wrlut r0,r2    
    if_nz   add b,a     '\ add old to newvalue
            wrlut b,r3  '\ store the value
            jmp #\@2DROP
end

code  lValE '\ value at auxstack in LUT with offset 
            mov r3,auxptr     
            sub r3,#5      '\ offset: -5
            mov r2,#tosetL
            >PUSHX         '\ space on stack
            rdlut a,r3     '\ get the value in tos
            rdlut r0,r2 wz  '\ get toset
   if_z     ret
            cmp r0,#1 wz    '\ check for store
            mov r0,#0   '\ clear toset
            wrlut r0,r2    
    if_nz   add b,a     '\ add old to newvalue
            wrlut b,r3  '\ store the value
            jmp #\@2DROP
end


( Adapted from: https://atariage.com/forums/topic/273092-forth-local-variables-for-the-common-man/ )
\ Mark Wills: http://turboforth.net/resources/simple_locals.html

        
: >a ( n -- ) to lValA ;
: >b ( n -- ) to lValB ;
: >c ( n -- ) to lValC ;
: >d ( n -- ) to lValD ;
: >e ( n -- ) to lValE ;
: a> ( -- n ) lValA ;
: b> ( -- n ) lValB ;
: c> ( -- n ) lValC ;
: d> ( -- n ) lValD ;
: e> ( -- n ) lValE ;

\ move stack frame
code lsp->
      add auxptr,#5
      ret
end
code <-lsp
      sub auxptr,#5
      ret
end


: loc lsp-> nop ; ( put 0 locals into local stack. loc_ geht nicht ! )
: loc_a lsp-> >a ; ( put 1 locals into local stack )
: loc_a_b lsp-> >b >a ; ( put 2 locals into local stack )
: loc_a_b_c lsp-> >c >b >a ; ( put 3 locals into local stack )
: loc_a_b_c_d lsp-> >d >c >b >a ; ( put 4 locals into local stack )
: loc_a_b_c_d_e lsp-> >e >d >c >b >a ; ( put 5 locals into local stack )
: endloc <-lsp ; ( free the local stack )
: testlocal loc_a_b_c ( a b c -- n ) a> b> - c> * endloc ;
( 5 2 7 testlocal . )

\ } Locals

\ } Variables_Library

: NamedLocals_Library ; ( { named locals Library ############################ )

\ https://www.complang.tuwien.ac.at/forth/gforth/Docs-html/Locals.html#Locals

\ pre ALIAS	[C] NFA' [G] DUP CFA [C] CREATE$ @WORDS CPA!   C@ $E0 AND @WORDS C+! ;
5 array locCFAs

nfa' lValA cfa 0 locCFAs !
nfa' lValB cfa 1 locCFAs !
nfa' lValC cfa 2 locCFAs !
nfa' lValD cfa 3 locCFAs !
nfa' lValE cfa 4 locCFAs !

nfa' lA# c@ $E0 AND [G] := locType \ type of word for locals

25 bytes nextName$
byte nextChar#
long locStat#   \ status
long locStack#  \ number of locals from stack
long locNum#    \ total number of locals
long names#


' endloc := endlocCFA
' loc := locCFA
' loc_a := loc_a_CFA
' loc_a_b := loc_b_CFA
' loc_a_b_c := loc_c_CFA
' loc_a_b_c_d := loc_d_CFA
' loc_a_b_c_d_e := loc_e_CFA


: initLoc \ allocate stack frame and initalize locals
    locStack# @ switch
        1 case locCFA [C] || break   
        2 case loc_a_CFA [C] || break
        3 case loc_b_CFA [C] || break
        4 case loc_c_CFA [C] || break
        5 case loc_d_CFA [C] || break
        6 case loc_e_CFA [C] || break       
; 

pre {: ( -- ) \ locals Syntax {: initLocal1 initLocal2 ... , nonInitLocal ... -- comment } 
    0 locStat# !    1 locStack# !   1 locNum# ! 
    names @ names# ! \ preserve names pointer
    begin
        wkey nextChar# c!
        \ crlf nextChar# c@ dup . emit locStat# @ . @words .long
            nextChar# c@ ',' = if \ end of initialised locals
                3 locStat# ! 
                nextChar# c@ emit
            else
                nextChar# c@ '-' = if \ end of locals, start of comment
                    1 locStat# ! 
                    nextChar# c@ emit
                else
                    nextChar# c@ '}' = if \ end of comment
                        2 locStat# !  
                        nextChar# c@ emit
                    else
                        locStat# @ 0 =   locStat# @ 3 = or if
                            nextChar# c@ key! \ write back to buffer
                            [C] CREATE$ \ create the alias name entry 
                            locNum# @ 1 - locCFAs @   @WORDS CPA!
                            locType @WORDS C+! 
                        then
                        locStat# @ 0 = if
                            1 locNum# +!
                            1 locStack# +!
                        then
                        locStat# @ 3 = if
                            1 locNum# +!
                        then  
                        locStat# @ 1 = if
                            nextChar# c@ emit
                        then 
                    then
                then
            then 
    locStat# @ 2 = until
    initLoc \ allocate stack frame and load locals
; \ }        


pre forgetLocals names# @ names ! ;

pre (;) \ new definition for named locals
    locNum# @ if         
        endlocCFA [C] [W] \ free stack frame
        0 locNum# ! 
        \ [C] forgetLocals \ forget the new local names 
    then
    [C] ; 
;

alias (;) ;

\ Fast Locals, that need cogmod

\ new cog registers for locals 
489 := acm
488 := bcm
487 := ccm
486 := dcm
485 := ecm

code cLoc ' \ make room for new locals on L-Stack
'      cmp auxptr,#128 wz
'   if_z _ret_ add auxptr,#5 ' \ just make room
'      sub auxptr,5          ' \ save the ones from calling
      wrlut ecm,auxptr
      add auxptr,#1
      wrlut dcm,auxptr
      add auxptr,#1
      wrlut ccm,auxptr
      add auxptr,#1
      wrlut bcm,auxptr
      add auxptr,#1
      wrlut acm,auxptr
   _ret_ add auxptr,#1
end

code cEndloc ' \ restore the ones from calling from L-Stack
      sub auxptr,#1 
      rdlut acm,auxptr
      sub auxptr,#1
      rdlut bcm,auxptr      
      sub auxptr,#1
      rdlut ccm,auxptr
      sub auxptr,#1
      rdlut dcm,auxptr
      sub auxptr,#1
   _ret_ rdlut ecm,auxptr
end

$086 := PUSHX

code CogModLocals ( cogmod for fast access to locals )
   mov acm,a ' \ >a
   jmp #\@DROP
   mov xx,acm ' \ a>
   jmp #\PUSHX
   mov bcm,a ' \ >b
   jmp #\@DROP
   mov xx,bcm ' \ b>
   jmp #\PUSHX   
   mov ccm,a ' \ >c
   jmp #\@DROP
   mov xx,ccm ' \ c>
   jmp #\PUSHX 
   mov dcm,a ' \ >d
   jmp #\@DROP
   mov xx,dcm ' \ d>
   jmp #\PUSHX   
   mov ecm,a ' \ >e
   jmp #\@DROP
   mov xx,ecm ' \ e>
   jmp #\PUSHX   
end

create$ >a 0 ' COGMOD + @words CPA W!
create$ a> 2 ' COGMOD + @words CPA W!
create$ >b 4 ' COGMOD + @words CPA W!
create$ b> 6 ' COGMOD + @words CPA W!
create$ >c 8 ' COGMOD + @words CPA W!
create$ c> 10 ' COGMOD + @words CPA W!
create$ >d 12 ' COGMOD + @words CPA W!
create$ d> 14 ' COGMOD + @words CPA W!
create$ >e 16 ' COGMOD + @words CPA W!
create$ e> 18 ' COGMOD + @words CPA W!

AT CogModLocals 2+ 28 LOADMOD 2drop \ bug in LOADMOD ==> 2drop



\ Examples:

{

: ltest2 {: rolf ina , sum -- summe } \ 2 locals initialized , 3 locals total 
    rolf ina + to sum
    sum . \ ( was not initialised from stack ) onto stack
; 
\ forgetLocals
: printSum {: numberL# , sumL# -- } \ 1 locals initialized , 2 locals total 
   0 to sumL#
   numberL# 1+ 0 do 
      i +to sumL#
   loop
   sumL# .
;



: inbds ( testval lowLimit hiLimit -- false_true ) \ traditional
    3RD >
    rot rot \ to get the first result out of the way 
    > and 
; 

: inbounds {: testval lowLimit hiLimit -- false_true } \ with named locals
    testval lowLimit >  
    testval hiLimit <   AND 
;

: lta {: num# }
    num# . ;

: fiboCogModLocals loc ( n -- f ) \ forth words for locals as inline code in cog
   AT CogModLocals 2+ 28 LOADMOD 2drop \ bug in LOADMOD ==> 2drop
    0 >a   1 >b   0 >c
    ( n ) for
        b> >a
        c> >b
        a> c> + >c
    next
    c> 
endloc ;

\ 46 lap fiboCogModLocals lap . .lap
    
}
   
\ }


: MemInfo_Library ; \ { #################################################################

: .cogs ( -- ) \ print the words running in cogs
    8 0 do
        crlf i . space i task w@ cfa>nfa .nfa
    loop
;

: .memscan \ print contents of memory
    crlf ." Memory scan: (1k)"
    $8.0000 0 do
        crlf+ i .l space
        $8000 0 do
            j i + @ dup 
            0 = if ." 0" drop
            else
                $0E0E0E0E = if ." v" \ Video
                else ." X" then
            then
        $400 +loop       
    $8000 +loop
;

: .memo \ print memory information
    .USAGE
    crlf+ ." Code:      " 0 .l ."  to " here .l
    crlf+ ." Words:     " @words .l ."  to " " END" SEARCH 6 + .l
    crlf+ ." Video:     " BMP .l ."  to " 
        SCR scrsz + .l
    crlf+ 
    crlf+ ." Original Data:   " $1800 .l ."  to " oriorg .l
    crlf+ ." User Data:       " userdata .l ."  to " org@ .l    
    crlf+ ." RX Buffer Start: " $7f500 .l
    crlf+ ." SD:              " sdbuf .l ."  to End"
    .memscan
;

\ .memo

\ } MemInfo_Library

: Misc_Library ; \ { ###############################################################


: 8b {: long# , result# -- result# } \ convert to 8bits
   0 to result#
   8 for
      long# 2 // i << +to result#
      long# 10 / to long#
   next
   result#
; forgetLocals


\ { Time ###############################################################

: time! ( hhmmss -- ) \ recalculate and set boot time
    HMS 60 * + 60 * + btime !
    getms bms !
;
 
: time@ ( -- hhmmss )
    qtime@ 240000 // ;

: time.
    qtime@ 240000 // .
;

: date.
    bdate @ . ;

value oldvtime#
: vtd. \ print time and date to vga
    time@ oldvtime# <> if
        time@ to oldvtime#
        500 5 vxy vga date. time. emit;
    then
;

\ } TIME

: page ( -- ) ( { clear ANSI terminal page )
    27 emit 91 emit
    50 emit
    74 emit
    0 0 %XY
; ( } )


: %savePos \ save cursor position
    27 emit 55 emit ;

: %restorePos \ restore cursor position
    27 emit 56 emit ;

: ttd. \ print time and date to terminal
    time@ oldvtime# <> if
        time@ to oldvtime#
        %savePos
        80 0 %xy date. time. 
        %restorePos
    then
;


\ slow gettext gett.fth 
{ 
pre GETTEXT \ End: Euro or ESC
    [C] FOPEN
    @FILE 0= IF 
        1 MB MAKE file$ FOPEN$ 0EXIT 
    THEN
    0 BEGIN WKEY 
        DUP emit
        DUP $1B <> \ esc
        over 128 <> and \ Euro
    WHILE OVER SDC! 1+ 
    REPEAT
    DROP 0 SWAP SDC! FCLOSE
;
}


\ { fast gettext #####################################

\ fast variant of SAVETEXT for longer text, has to wait for SD-card
\ Usage: RW gettext file.fth This is the text ESC

SCR := textbuf \ was $6c000 

: getbuf ( -- length )
    0 BEGIN WKEY 
        DUP emit
        DUP $1B <> \ esc
        over 128 <> and \ Euro
    WHILE 
        OVER textbuf + C! 1+ 
    REPEAT
    drop 
    0 over textbuf + C! 
    1+
;

: .buffer
    0
    crlf
    begin
        dup textbuf + c@
    dup while
        emit 1+
    repeat
    drop
    crlf . ." Bytes " crlf
;

long sdpause

pre GETTEXT \ Usage: RWC gettext AUTO.F This is the text ESC
    [C] FOPEN
    @FILE 0= IF 
        1 MB MAKE file$ FOPEN$ 0EXIT 
    THEN   
    getbuf 
    sdpause ~
    ( length ) 0 do
        i textbuf + c@
        i sdc!
        sdpause dup ++ @ 510 > if sdpause ~ 2 ms then 
    loop
    FCLOSE
;


\ } fast gettext


\ { Heart Beat Polling ############################################################

: outsec \ copies time bit to pin 57 ( led of Kiss board )
    getms 9 >> 1 and 57 pin!
;
\ !polls \ clear polling tasks

\ ' outsec +poll \ funktioniert

\ } Polling
    
\ } Misc_Library 

: toInit
   0 tosetL LUT! ;

\ Don't forget to include toInit, when starting a cog!!!



8 BPP 360p !VGA 
VGA 'A' EMIT -mono emit;
vclr

\ ' dcfSet 1 run

!polls
\ ' vtd. +poll
\ ' ttd. +poll
\ €
