{   
   Profile_C.fth
   needs AutoQ.fth
   
   28.04.23 Christof Eberspaecher 
   
}

\ !polls \ clear multitasking

IFDEF *Profile*	
    oldorgP org
    FORGET *Tests*	 }

pub *Profile*	    PRINT" P2 Prifile_C.fth" ;

0 bytes oldorgP

\ Timer event and toggle pin P2 Docu Page 51 uses cog register deltaR

57 := ledPin
$1c := deltaR
1001 := deltaCnt    \ 200_000_000 one second @ 200 MHz

$1ED := hr0 \ tracing registers used here!
$1EC := hr1
$1EB := hr2
$1ee := xreg
$1ef := traceL

$0f := x
$17 := retptr \ return stack pointer
$15 := auxptr

$5d4 := prtIP
$4bc := prtHex
$0a4 := prtName
$5f8 = prtCrlf

SCR 64 KB + := startOccure 

code isrProfile           ' counts occurances
   drvnot #ledPin
      add deltaR,traceL   ' set new interrupt
      addct1 deltaR,#0
      mov hr0,retptr        ' stack position 
   .l1   rdlut xreg,hr0     ' address
      sub xreg,#2
      rdword xreg,xreg      ' word code
      add xreg,##startOccure
      rdword hr2,xreg
      add hr2,#1
      cmp hr2,##$ffff wz   ' prevent overflow
      if_z setint2 #0
      wrword hr2,xreg
      sub hr0,#1
      cmp hr0,#$40 wz
   if_nz jmp #l1
   reti2
end


$1f2 := ijmp2
' isrProfile 2 + := isr2 \ get asm start address

code startIsr
   mov ijmp2,#isr2         ' get vector
   setint2 #1              ' CT-passed-CT1, established by ADDCT1
   getct deltaR
   add deltaR,traceL
   addct1 deltaR,#0        ' establish time   
   ret
end

code stopIsr
   setint2 #0
   ret
end

code prtName ( cfa -- )
   mov xreg,a
   mov x,a
   call #\$4bc          ' print word code
   call #\$4f8
   jmp #\@DROP
end

: getMaxOc ( -- maxOccurance )
   0
   32 KB for
      i 2* startOccure + w@ maxs
   next
;

: prtOccur {: , maxO# }
   getMaxOc to maxO#
   crlf
   32 KB for
      i 2* startOccure + w@ if
         crlf i 2* dup .M ."  "
         dup startOccure + w@ 
         dup 8 .decs ."  "
         10000 maxO# */ .AS" ###\.##% "
         \ prtName
         CFA>NFA ?DUP if .NFA then
         \ CFA>NFA ?DUP IF .NAME THEN
      then
   next
; forgetLocals

\ 0350A is USRKEY
\ 0AD4C is VALUE
\ 
\ TestCase #################################################################

code dummyCode
   mov r1,##200
   .l1 djnz r1,#l1
   ret
end    

code dummyCodeFor
   mov r1,##200
   FOR:
      nop
   NEXT: r1
   ret
end   

: dummyLoop
   200 for
   next
;

: dummydummy ;

: prtCalc ( -- )
   2000 for
      dummydummy
      I 250 + 300 - 
      i sqrt drop \ .
      
      dummyLoop
      dummyCode
      dummyCodeFor
   next
;


: profPrtCalc \ profile the word prtCalc
   startOccure 64 KB ERASE \ here is at ~ 48k, plenty of space
   startIsr
   prtCalc
   stopIsr
   prtOccur
;

5001 traceL cog! \ cycles between interrupts
profPrtCalc

{
: profStrip
   startOccure 64 KB ERASE \ here is at ~ 48k, plenty of space
   startIsr
   stripText
   stopIsr
   prtOccur
;

\ 10001 traceL cog!  
\ profStrip
}

{
: profFibo
   startOccure 64 KB ERASE \ here is at ~ 48k, plenty of space
   startIsr
   .compare
   stopIsr
   prtOccur
;

701 traceL cog!  
profFibo
}